package pract12;



import fundamentos.*;

/**
 * Clase principal del programa de gestión de las rutas de un GPS
 * 
 * @author  Metodos de Programacion (UC)
 * @version may-15
 */
public class GestionGPS {


	/**
	 * Método principal que muestra un menú con las opciones
	 */
	public static void main(String[] args) {
		final int ANHADIR_RUTA=1, CARGAR_FICHERO_DATOS = 2, CARGAR_FICHERO_OBJETO= 3, 
				CREAR_FICHERO_DATOS = 4, CREAR_FICHERO_OBJETO= 5;
		Ruta ruta;
		String nomFich;

		// crea menu y anhade las opciones
		Menu m = new Menu("Gestion GPS");
		m.insertaOpcion("Anhadir ruta", ANHADIR_RUTA);
		m.insertaOpcion("Cargar binario datos", CARGAR_FICHERO_DATOS);
		m.insertaOpcion("Crear binario datos", CREAR_FICHERO_DATOS);
		m.insertaOpcion("Cargar binario objeto", CARGAR_FICHERO_OBJETO);
		m.insertaOpcion("Crear binario objeto", CREAR_FICHERO_OBJETO);
		int opcion;

		// crea el GPS sin ninguna ruta
		RutasGPS gps= new RutasGPS();

		// lazo de espera de comandos del usuario
		while (true) {
			opcion = m.leeOpcion();

			// realiza las acciones dependiendo de la opcion elegida
			switch (opcion) {
			case ANHADIR_RUTA:
				// crea la ruta
				ruta = pideDatosYCreaRuta();
				
				// anhade la ruta
				gps.anhadeRuta(ruta);
				
				// muestra todas las rutas almacenadas
				muestraRutas(gps);
				break;

			case CARGAR_FICHERO_DATOS:
				// crea una ventana de lectura para leer el nombre del fichero
				Lectura lect = new Lectura("Fichero binario de rutas");
				lect.creaEntrada("Nombre Fichero", "");
				lect.esperaYCierra();

				// espera a que el usuario pulse aceptar y lee el nombre del fichero
				nomFich = lect.leeString("Nombre Fichero");
				
				// crea un gps con los datos almacenados en el fichero
				// TODO
				
				// muestra todas las rutas almacenadas
				muestraRutas(gps);
				break;

			case CREAR_FICHERO_DATOS:
				// crea una ventana de lectura para leer el nombre del fichero
				Lectura lectv = new Lectura("Volcar a binario de rutas");
				lectv.creaEntrada("Nombre Fichero", "");
				lectv.esperaYCierra();

				// espera a que el usuario pulse aceptar y lee el nombre del fichero
				nomFich = lectv.leeString("Nombre Fichero");
				
				// crea un fichero binario de datos con los datos actuales del gps
				// TODO
				break;

			case CARGAR_FICHERO_OBJETO:
				// crea una ventana de lectura para leer el nombre del fichero
				Lectura lectObj = new Lectura("Fichero binario de rutas");
				lectObj.creaEntrada("Nombre Fichero", "");
				lectObj.esperaYCierra();

				// espera a que el usuario pulse aceptar y lee el nombre del fichero
				nomFich = lectObj.leeString("Nombre Fichero");
				
				// crea un gps con los datos almacenados en el fichero
				// TODO
				
				// muestra todas las rutas almacenadas
				muestraRutas(gps);
				break;

			case CREAR_FICHERO_OBJETO:
				// crea una ventana de lectura para leer el nombre del fichero
				Lectura lectvo = new Lectura("Volcar a binario de rutas");
				lectvo.creaEntrada("Nombre Fichero", "");
				lectvo.esperaYCierra();

				// espera a que el usuario pulse aceptar y lee el nombre del fichero
				nomFich = lectvo.leeString("Nombre Fichero");
				
				// crea un fichero binario de objeto con los datos actuales del gps
				// TODO
				break;
			}
		}
	}
	
	/**
	 * Muestra todas las rutas almacenadas en el GPS en una caja de texto
	 * del paquete fundamentos
	 * @param gps gps del que se van a mostrar las rutas
	 */
	private static void muestraRutas(RutasGPS gps){
		Ruta[] rutas = gps.rutas();
		CajaTexto caja = new CajaTexto("Coordenadas", 20, 20);
		caja.println("************** RUTAS ***************************");
		for (int i= 0; i<rutas.length; i++){
			caja.println("RUTA "+i+"  Origen: "+rutas[i].origen()+"   Destino: "+rutas[i].destino());
			Coordenada[] coords = rutas[i].coordenadas();
			for (Coordenada c: coords) {
				caja.println("      Latitud: "+c.latitud+"   Longitud: "+c.longitud);
			}
			caja.println("");
		}
		caja.esperaYCierra();
	}
	
	/**
	 * Pide los datos necesarios para crear una ruta y la crea
	 * @return la ruta creada
	 */
	private static Ruta pideDatosYCreaRuta() {
		// crea la ventana de lectura
		Lectura lect = new Lectura("Datos Ruta");
		lect.creaEntrada("Origen", "");
		lect.creaEntrada("Destino", "");

		// espera a que el usuario pulse aceptar y lee los datos
		lect.esperaYCierra();	
		String origen = lect.leeString("Origen");
		String destino = lect.leeString("Destino");
		
		// crea la ruta
		Ruta ruta = new Ruta(origen, destino);

		// crea la ventana de lectura para las coordenadas
		CajaTexto caja = new CajaTexto("Coordenadas", 20, 20);
		caja.esperaYCierra();
		
		// lee los datos introducidos
		while (caja.hayMas()) {
			double latitud = caja.leeDouble(0);
			double longitud = caja.leeDouble(1);
			caja.avanzaLinea();
			
			// crea una nueva coordenada y se la anhade a la ruta
			Coordenada c = new Coordenada(latitud, longitud);
			ruta.addCoordenada(c);
		}

		return ruta;
	}

	/**
	 * Metodo auxiliar que muestra un ventana de mensaje
	 * @param titulo titulo de la ventana
	 * @param txt texto contenido en la ventana
	 */
	private static void mensaje(String titulo, String txt) {
		Mensaje msj = new Mensaje(titulo);
		msj.escribe(txt);

	}
}
