package pract12;

import java.util.ArrayList;

/**
 * Clase que representa una ruta para ir de un punto 
 * origen a un punto destino, almacenando el conjunto de coordenadas
 * que representan los puntos intermedios de la ruta.
 * 
 * @author  Metodos de Programacion (UC) y <TODO nombre alumno>
 * @version may-15
 */
public class Ruta {
	
	// String que identifica la direccion o punto de origen
	private final String origen;
	
	// String que identifica la direccion o punto de destino
	private final String destino;
	
	// Array de coordenadas con los puntos intermedios de la ruta
	private ArrayList<Coordenada> coordenadas;
	
	/**
	 * Constructor que crea una ruta con el origen y el destino dados
	 * y sin coordenadas intermedias
	 * @param origen Direccion de origen de la ruta
	 * @param destino Direccion de destino de la ruta
	 */
	public Ruta(String origen, String destino){
		this.origen = origen;
		this.destino = destino;
		this.coordenadas = new ArrayList<Coordenada>();
	}
	
	/**
	 * Retorna la direccion de origen de la ruta
	 * @return  direccion de origen  de la ruta
	 */
	public String origen(){
		return origen;
	}
	
	/**
	 * Retorna la direccion de destino de la ruta
	 * @return  direccion de destino de la ruta
	 */
	public String destino(){
		return destino;
	}
	
	/**
	 * Anhade una nueva coordenada intermedia a la ruta
	 * @param c Coordenada a anhadir
	 */
	public void addCoordenada(Coordenada c){
		coordenadas.add(c);
	}
	
	/**
	 * Retorna una copia de las coordenadas de la ruta
	 * @return un array con una copia de las coordenadas de la ruta
	 */
	public Coordenada[] coordenadas(){
		return coordenadas.toArray(new Coordenada[0]);
	}

}
